/*
 * Hypercube API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.2.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.nfvmano.sbi.starfish.model;

import java.io.IOException;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * An enumeration.
 */
@JsonAdapter(ModcodNameEnum.Adapter.class)
public enum ModcodNameEnum {
  QPSK_1_4("QPSK 1/4"),
  QPSK_1_3("QPSK 1/3"),
  QPSK_2_5("QPSK 2/5"),
  QPSK_1_2("QPSK 1/2"),
  QPSK_3_5("QPSK 3/5"),
  QPSK_2_3("QPSK 2/3"),
  QPSK_3_4("QPSK 3/4"),
  QPSK_4_5("QPSK 4/5"),
  QPSK_5_62("QPSK 5/62"),
  QPSK_8_9("QPSK 8/9"),
  _8PSK_2_3("8PSK 2/3"),
  _8PSK_3_4("8PSK 3/4"),
  _8PSK_5_6("8PSK 5/6"),
  _16APSK_3_4("16APSK 3/4"),
  _16APSK_4_5("16APSK 4/5"),
  _16APSK_5_6("16APSK 5/6");

  private String value;

  ModcodNameEnum(String value) {
    this.value = value;
  }

  public String getValue() {
    return value;
  }

  @Override
  public String toString() {
    return String.valueOf(value);
  }

  public static ModcodNameEnum fromValue(String input) {
    for (ModcodNameEnum b : ModcodNameEnum.values()) {
      if (b.value.equals(input)) {
        return b;
      }
    }
    return null;
  }

  public static class Adapter extends TypeAdapter<ModcodNameEnum> {
    @Override
    public void write(final JsonWriter jsonWriter, final ModcodNameEnum enumeration) throws IOException {
      jsonWriter.value(String.valueOf(enumeration.getValue()));
    }

    @Override
    public ModcodNameEnum read(final JsonReader jsonReader) throws IOException {
      Object value = jsonReader.nextString();
      return ModcodNameEnum.fromValue((String)(value));
    }
  }
}
